Foreman - Refactor #14094

Replace DB migration foreign_keys calls with foreign_key_exists?

03/08/2016 07:41 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: DB migrations
Target version: 1.12.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3290
Description

In Rail 4.2 and higher, where native foreign key support replaces Foreigner, the "foreign_keys" call inside a DB migration should be
avoided as it will throw an exception on databases (SQLite) that don't support FKs.

https://github.com/rails/rails/blob/6298ac705da92cc793cbf40dd91484d34e01d255/activerecord/lib/active_record/connection_adapter

s/abstract/schema_statements.rb#L671

In Foreigner, it returned [] on SQLite. In #13244 (Rails 4.2) I'll add a compatibility layer with a deprecation warning, but our
migrations that use this to check whether a key exists should just use the foreign_key_exists? method for better compatibility.

Related issues:
Blocks Foreman - Feature #13244: Upgrade Ruby on Rails to 4.2

Closed 01/15/2016

Associated revisions

Revision d273d9cf - 03/08/2016 10:58 AM - Dominic Cleal
fixes #14094 - replace foreign_keys calls with foreign_key_exists?
foreign_keys throws an exception under SQLite in Rails 4.2, so prefer

the _exists? call to check for presence of a key as it returns false on
DBs without FK support.

History

#1 - 03/08/2016 07:44 AM - Dominic Cleal
- Blocks Feature #13244: Upgrade Ruby on Rails to 4.2 added

#2 - 03/08/2016 07:44 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3290 added

#3 - 03/08/2016 11:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset d273d9cfdec2192cf7{22f1f3a69d51c413b9647.

#4 - 03/09/2016 09:53 AM - Dominic Cleal

- translation missing: en.field_release set to 136

05/17/2024
